@echo off
set mypmv=v3.9
if not exist %windir%\date.exe goto needexes
if exist %windir%\blat.exe goto gotexes
:needexes
echo pingmon: ping an address every x seconds, log/email on state change (%mypmv%)
echo usage:   this utility requires the following files IN WINDIR (%windir%):
echo usage:     date.exe   - see http://unxutils.sourceforge.net/
echo usage:     blat.exe   - see http://www.blat.net (must be configured too:
echo usage:                  blat -install mailserver.name.or.ip from@address 35)
echo usage:   please provide the necessary files before rerunning this utility
goto quitnow
:gotexes
if not "%5"=="" goto okparm
echo pingmon: ping an address every x seconds, log/email on state change (%mypmv%)
echo usage:   pingmon computer frequency emailaddress logfile csvfile [mailserver]
echo usage:     computer     = computer name or IP address
echo usage:     frequency    = seconds between ping attempts
echo usage:     emailaddress = valid email address, or period for no email
echo usage:     logfile      = complete log file name, or period for no log file
echo usage:     csvfile      = complete csv file name, or period for no csv log
echo usage:     mailserver   = optional mail server to override blat setting
echo usage:   note, use valid email address and file names, no checking is done
goto quitnow
::---------------------------------------------------------------
:okparm
set /a pingfreq=%2+1
set pingmonmail1=
set pingmonmail2=
if "%6"=="" goto okmail
set pingmonmail1=-server
set pingmonmail2=%6
:okmail
set pingmondown=0
set pingmonup=0
set pingmonspan=0
for /f %%i in ('%windir%\date.exe +%%s') do set pingmonup=%%i
for /f %%i in ('%windir%\date.exe +%%s') do set pingmondown=%%i
ping -n 1 %1 | find /i "bytes="
if errorlevel==1 goto :isdownstart
:isupstart
if not "%3"=="." start blat.exe - -ti 120 -to %3 -s "Pingmon: Monitoring %1, initial state is -UP- at %date% %time%" %pingmonmail1% %pingmonmail2% -body "parms:|  address    %1|  frequency  %2|  notify     %3|  logfile    %4|  csvlog     %5|  mailserver %6|  watcher    %COMPUTERNAME%|  version    %mypmv%"
if not "%4"=="." echo %1 initial state is -UP- at %date% %time%.  Parms: address=%1, frequency=%2, notify=%3, logfile=%4, csvlog=%5, mailserver=%6, watcher=%COMPUTERNAME%, version=%mypmv% >> %4
if not "%5"=="." echo "up","%date%","%time%","%1","","%COMPUTERNAME%","%mypmv%" >> %5
goto isup
:isdownstart
for /f %%i in ('%windir%\date.exe +%%s') do set pingmondown=%%i
if not "%3"=="." start blat.exe - -ti 120 -to %3 -s "Pingmon: Monitoring %1, initial state is DOWN at %date% %time%" %pingmonmail1% %pingmonmail2% -body "parms:|  address    %1|  frequency  %2|  notify     %3|  logfile    %4|  csvlog     %5|  mailserver %6|  watcher    %COMPUTERNAME%|  version    %mypmv%"
if not "%4"=="." echo %1 initial state is DOWN at %date% %time%.  Parms: address=%1, frequency=%2, notify=%3, logfile=%4, csvlog=%5, mailserver=%6, watcher=%COMPUTERNAME%, version=%mypmv% >> %4
if not "%5"=="." echo "down","%date%","%time%","%1","","%COMPUTERNAME%","%mypmv%" >> %5
goto isdown
::---------------------------------------------------------------
:isup
ping -n %pingfreq% 127.0.0.1>NUL
ping -n 1 %1 | find /i "bytes="
if errorlevel==1 goto uptodown
goto isup
:uptodown
for /f %%i in ('%windir%\date.exe +%%s') do set pingmondown=%%i
set /a pingmonspan=%pingmondown%-%pingmonup%
if not "%3"=="." start blat.exe - -ti 120 -to %3 -s "Pingmon: %1 now DOWN (was up %pingmonspan% sec) at %date% %time%" %pingmonmail1% %pingmonmail2% -body "parms:|  address    %1|  frequency  %2|  notify     %3|  logfile    %4|  csvlog     %5|  mailserver %6|  watcher    %COMPUTERNAME%"
if not "%4"=="." echo DOWN %date% %time%   %1 (was up %pingmonspan% sec) >> %4
if not "%5"=="." echo "down","%date%","%time%","%1","%pingmonspan%","%COMPUTERNAME%","%mypmv%" >> %5
goto isdown
::---------------------------------------------------------------
:isdown
ping -n %pingfreq% 127.0.0.1>NUL
ping -n 1 %1 | find /i "bytes="
if not errorlevel==1 goto downtoup
goto isdown
:downtoup
for /f %%i in ('%windir%\date.exe +%%s') do set pingmonup=%%i
set /a pingmonspan=%pingmonup%-%pingmondown%
if not "%3"=="." start blat.exe - -ti 120 -to %3 -s "Pingmon: %1 now UP (was down %pingmonspan% sec) at %date% %time%" %pingmonmail1% %pingmonmail2% -body "parms:|  address    %1|  frequency  %2|  notify     %3|  logfile    %4|  csvlog     %5|  mailserver %6|  watcher    %COMPUTERNAME%"
if not "%4"=="." echo UP   %date% %time% + %1 (was down %pingmonspan% sec) >> %4
if not "%5"=="." echo "up","%date%","%time%","%1","%pingmonspan%","%COMPUTERNAME%","%mypmv%" >> %5
goto isup
::---------------------------------------------------------------
::(c)Bill Aycock 2017 - freely distributable under GPL v3 license
:quitnow
